<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLContainersAggregate&lt; AlgData &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classAggInfo-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLContainersAggregate&lt; AlgData &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__core.html">Core Classes</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>base class for aggregate information  
 <a href="classAggInfo.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersAggregate_8hpp_source.html">tiglContainersAggregate.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a4f4f5a3183bfed15fb25f8564ef1137c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a4f4f5a3183bfed15fb25f8564ef1137c">localAggregateInit</a> (uint_fast32_t ssIndex, uint_fast32_t numLocActiveNodes)</td></tr>
<tr class="memdesc:a4f4f5a3183bfed15fb25f8564ef1137c"><td class="mdescLeft">&#160;</td><td class="mdescRight">reseting the aggregate parameters before the new superstep  <a href="#a4f4f5a3183bfed15fb25f8564ef1137c">More...</a><br /></td></tr>
<tr class="separator:a4f4f5a3183bfed15fb25f8564ef1137c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a816fe8ed65f8c026c96e36a17e149f2e"><td class="memTemplParams" colspan="2">template&lt;typename VERTEX_ITERATOR &gt; </td></tr>
<tr class="memitem:a816fe8ed65f8c026c96e36a17e149f2e"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a816fe8ed65f8c026c96e36a17e149f2e">localAggregateUpdate</a> (VERTEX_ITERATOR vertexIt, uint_fast32_t currNumMessages)</td></tr>
<tr class="memdesc:a816fe8ed65f8c026c96e36a17e149f2e"><td class="mdescLeft">&#160;</td><td class="mdescRight">updating the aggregate information after a single node execution during a superstep  <a href="#a816fe8ed65f8c026c96e36a17e149f2e">More...</a><br /></td></tr>
<tr class="separator:a816fe8ed65f8c026c96e36a17e149f2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8053ab15460a14476c7a71371b1d2d6d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8053ab15460a14476c7a71371b1d2d6d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a8053ab15460a14476c7a71371b1d2d6d">externalAggregateUpdate</a> (<a class="el" href="classAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> *aggSysInfo)</td></tr>
<tr class="memdesc:a8053ab15460a14476c7a71371b1d2d6d"><td class="mdescLeft">&#160;</td><td class="mdescRight">updating the aggregate information after receiving an update from other devices <br /></td></tr>
<tr class="separator:a8053ab15460a14476c7a71371b1d2d6d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aadbf3019d3dfe78da479e1e69befc203"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#aadbf3019d3dfe78da479e1e69befc203">prepareAggregateSysMessage</a> (<a class="el" href="classAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> *aggSysInfo)</td></tr>
<tr class="memdesc:aadbf3019d3dfe78da479e1e69befc203"><td class="mdescLeft">&#160;</td><td class="mdescRight">Preparing the aggregate information system message (at the end of the superstep)  <a href="#aadbf3019d3dfe78da479e1e69befc203">More...</a><br /></td></tr>
<tr class="separator:aadbf3019d3dfe78da479e1e69befc203"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaaf42f7c6d8e017f0d57ece43bbd829c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#aaaf42f7c6d8e017f0d57ece43bbd829c">incrementExternalMessagesCount</a> (uint_fast32_t currNumMessages)</td></tr>
<tr class="memdesc:aaaf42f7c6d8e017f0d57ece43bbd829c"><td class="mdescLeft">&#160;</td><td class="mdescRight">incrementing the number of exteranl Messages after a single node compute in a superstep  <a href="#aaaf42f7c6d8e017f0d57ece43bbd829c">More...</a><br /></td></tr>
<tr class="separator:aaaf42f7c6d8e017f0d57ece43bbd829c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5bdf6265b94980fd94f690af72ec777f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a5bdf6265b94980fd94f690af72ec777f">setNumLocalActiveNoes</a> (uint_fast32_t numActive)</td></tr>
<tr class="memdesc:a5bdf6265b94980fd94f690af72ec777f"><td class="mdescLeft">&#160;</td><td class="mdescRight">set the number of local active nodes at the end of a superstep  <a href="#a5bdf6265b94980fd94f690af72ec777f">More...</a><br /></td></tr>
<tr class="separator:a5bdf6265b94980fd94f690af72ec777f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a453b0754a7c5e287f3de647e1c06d012"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a453b0754a7c5e287f3de647e1c06d012"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a453b0754a7c5e287f3de647e1c06d012">getNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a453b0754a7c5e287f3de647e1c06d012"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of external messages in the current superstep <br /></td></tr>
<tr class="separator:a453b0754a7c5e287f3de647e1c06d012"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8cda22ab749825787af2e351fb0c785d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8cda22ab749825787af2e351fb0c785d"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a8cda22ab749825787af2e351fb0c785d">getPastNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a8cda22ab749825787af2e351fb0c785d"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of external messages in the previous superstep <br /></td></tr>
<tr class="separator:a8cda22ab749825787af2e351fb0c785d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ee39b2641ee2c657515361cd4673e0e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8ee39b2641ee2c657515361cd4673e0e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a8ee39b2641ee2c657515361cd4673e0e">getNumTotalMessages</a> ()</td></tr>
<tr class="memdesc:a8ee39b2641ee2c657515361cd4673e0e"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the total number of output messages of the device in the current superstep <br /></td></tr>
<tr class="separator:a8ee39b2641ee2c657515361cd4673e0e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd971516d03353859ec78c56dcb170be"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abd971516d03353859ec78c56dcb170be"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#abd971516d03353859ec78c56dcb170be">getPastNumTotalMessages</a> ()</td></tr>
<tr class="memdesc:abd971516d03353859ec78c56dcb170be"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the total number of output messages of the device in the previous superstep <br /></td></tr>
<tr class="separator:abd971516d03353859ec78c56dcb170be"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3128d6b3a269936ff0e542d9b64914e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab3128d6b3a269936ff0e542d9b64914e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#ab3128d6b3a269936ff0e542d9b64914e">getNumVertices</a> ()</td></tr>
<tr class="memdesc:ab3128d6b3a269936ff0e542d9b64914e"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the total number of vertices in the whole graph <br /></td></tr>
<tr class="separator:ab3128d6b3a269936ff0e542d9b64914e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3295d863c695cd038d4f21ae4e723020"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3295d863c695cd038d4f21ae4e723020"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a3295d863c695cd038d4f21ae4e723020">setNumVertices</a> (uint_fast32_t num)</td></tr>
<tr class="memdesc:a3295d863c695cd038d4f21ae4e723020"><td class="mdescLeft">&#160;</td><td class="mdescRight">sets the total number of vertices in the whole graph <br /></td></tr>
<tr class="separator:a3295d863c695cd038d4f21ae4e723020"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab69c1408aeeb9f875144a5c62b52fde7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab69c1408aeeb9f875144a5c62b52fde7"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#ab69c1408aeeb9f875144a5c62b52fde7">getNumLocalVertices</a> ()</td></tr>
<tr class="memdesc:ab69c1408aeeb9f875144a5c62b52fde7"><td class="mdescLeft">&#160;</td><td class="mdescRight">retruns the number of local vertices <br /></td></tr>
<tr class="separator:ab69c1408aeeb9f875144a5c62b52fde7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e072226e6f62185261706f4f327d5fd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0e072226e6f62185261706f4f327d5fd"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a0e072226e6f62185261706f4f327d5fd">setNumLocalVertices</a> (uint_fast32_t num)</td></tr>
<tr class="memdesc:a0e072226e6f62185261706f4f327d5fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">sets the number of local vertices <br /></td></tr>
<tr class="separator:a0e072226e6f62185261706f4f327d5fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b70ffe78a57d6e7c653ecf1fec335a5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0b70ffe78a57d6e7c653ecf1fec335a5"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a0b70ffe78a57d6e7c653ecf1fec335a5">getNumSS</a> ()</td></tr>
<tr class="memdesc:a0b70ffe78a57d6e7c653ecf1fec335a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the superstep count <br /></td></tr>
<tr class="separator:a0b70ffe78a57d6e7c653ecf1fec335a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6129464657e507c1215f3e1e6702081d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6129464657e507c1215f3e1e6702081d"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a6129464657e507c1215f3e1e6702081d">getMaxActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a6129464657e507c1215f3e1e6702081d"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the maximum value of the algorithm data of all active nodes for the current superstep <br /></td></tr>
<tr class="separator:a6129464657e507c1215f3e1e6702081d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3d20ae3cc002791fdaca8fb656b477a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad3d20ae3cc002791fdaca8fb656b477a"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#ad3d20ae3cc002791fdaca8fb656b477a">getPastMaxActiveAlgData</a> ()</td></tr>
<tr class="memdesc:ad3d20ae3cc002791fdaca8fb656b477a"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the maximum value of the algorithm data of all active nodes for the previous superstep <br /></td></tr>
<tr class="separator:ad3d20ae3cc002791fdaca8fb656b477a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9976289825d64ffc1702eee9d58ae28e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9976289825d64ffc1702eee9d58ae28e"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a9976289825d64ffc1702eee9d58ae28e">getMinActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a9976289825d64ffc1702eee9d58ae28e"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the minimum value of the algorithm data of all active nodes for the current superstep <br /></td></tr>
<tr class="separator:a9976289825d64ffc1702eee9d58ae28e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2575c2c465e71141d2cbd9631b9080c6"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2575c2c465e71141d2cbd9631b9080c6"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a2575c2c465e71141d2cbd9631b9080c6">getPastMinActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a2575c2c465e71141d2cbd9631b9080c6"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the minimum value of the algorithm data of all active nodes for the previous superstep <br /></td></tr>
<tr class="separator:a2575c2c465e71141d2cbd9631b9080c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55085f6099a4c84bdbe0c9c57df7758d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a55085f6099a4c84bdbe0c9c57df7758d"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a55085f6099a4c84bdbe0c9c57df7758d">getSumActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a55085f6099a4c84bdbe0c9c57df7758d"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the sum of the algorithm data of all active nodes for the current superstep <br /></td></tr>
<tr class="separator:a55085f6099a4c84bdbe0c9c57df7758d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c6117841204067e5fa705d3b9696e69"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1c6117841204067e5fa705d3b9696e69"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a1c6117841204067e5fa705d3b9696e69">getPastSumActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a1c6117841204067e5fa705d3b9696e69"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the sum of the algorithm data of all active nodes for the previous superstep <br /></td></tr>
<tr class="separator:a1c6117841204067e5fa705d3b9696e69"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a52568c479ce2aaf14af4149992147a4a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a52568c479ce2aaf14af4149992147a4a"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a52568c479ce2aaf14af4149992147a4a">numVertices</a></td></tr>
<tr class="memdesc:a52568c479ce2aaf14af4149992147a4a"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of vertices in the graph <br /></td></tr>
<tr class="separator:a52568c479ce2aaf14af4149992147a4a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b771b26f66f5b4f43e65818b792fbd4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4b771b26f66f5b4f43e65818b792fbd4"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a4b771b26f66f5b4f43e65818b792fbd4">numLocalVertices</a></td></tr>
<tr class="memdesc:a4b771b26f66f5b4f43e65818b792fbd4"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of local vertices for this device <br /></td></tr>
<tr class="separator:a4b771b26f66f5b4f43e65818b792fbd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2749326b7d6ba1c35341296bbd41306a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2749326b7d6ba1c35341296bbd41306a"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a2749326b7d6ba1c35341296bbd41306a">countSS</a></td></tr>
<tr class="memdesc:a2749326b7d6ba1c35341296bbd41306a"><td class="mdescLeft">&#160;</td><td class="mdescRight">superstep counter <br /></td></tr>
<tr class="separator:a2749326b7d6ba1c35341296bbd41306a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a425869fb41b4276d4a0537ab9d6d7dc9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a425869fb41b4276d4a0537ab9d6d7dc9"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a425869fb41b4276d4a0537ab9d6d7dc9">numTotalMessages</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a425869fb41b4276d4a0537ab9d6d7dc9"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of output messages over a superstep history <br /></td></tr>
<tr class="separator:a425869fb41b4276d4a0537ab9d6d7dc9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff294148009304540d45b611213904a7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aff294148009304540d45b611213904a7"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#aff294148009304540d45b611213904a7">numExternalMessages</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:aff294148009304540d45b611213904a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of external output messages over a superstep history <br /></td></tr>
<tr class="separator:aff294148009304540d45b611213904a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d40305b2874a639cc626fc37af314e0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8d40305b2874a639cc626fc37af314e0"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a8d40305b2874a639cc626fc37af314e0">numLocalActiveNodes</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a8d40305b2874a639cc626fc37af314e0"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of local active nodes over a superstep history <br /></td></tr>
<tr class="separator:a8d40305b2874a639cc626fc37af314e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af49673c608f65071128d742159ad6a3e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af49673c608f65071128d742159ad6a3e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#af49673c608f65071128d742159ad6a3e">numTotalActiveNodes</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:af49673c608f65071128d742159ad6a3e"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of active nodes over a superstep history <br /></td></tr>
<tr class="separator:af49673c608f65071128d742159ad6a3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d8b931a11e6298c43cce7846cb1559b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5d8b931a11e6298c43cce7846cb1559b"></a>
AlgData&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a5d8b931a11e6298c43cce7846cb1559b">maxActiveAlgData</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a5d8b931a11e6298c43cce7846cb1559b"><td class="mdescLeft">&#160;</td><td class="mdescRight">maximum value of algorithm data of all active vertices over a superstep history <br /></td></tr>
<tr class="separator:a5d8b931a11e6298c43cce7846cb1559b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3490db3b1c5f6d043cdc8e1985f12fd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac3490db3b1c5f6d043cdc8e1985f12fd"></a>
AlgData&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#ac3490db3b1c5f6d043cdc8e1985f12fd">minActiveAlgData</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:ac3490db3b1c5f6d043cdc8e1985f12fd"><td class="mdescLeft">&#160;</td><td class="mdescRight">minimum value of algorithm data of all active vertices over a superstep history <br /></td></tr>
<tr class="separator:ac3490db3b1c5f6d043cdc8e1985f12fd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c6790ad56e989b8fb10b42e91bfb009"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8c6790ad56e989b8fb10b42e91bfb009"></a>
AlgData&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a8c6790ad56e989b8fb10b42e91bfb009">sumActiveAlgData</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a8c6790ad56e989b8fb10b42e91bfb009"><td class="mdescLeft">&#160;</td><td class="mdescRight">the sum of the values of algorithm data of all active vertices over a superstep history <br /></td></tr>
<tr class="separator:a8c6790ad56e989b8fb10b42e91bfb009"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e3a9e37e2c67fcba5320f5ec7fce767"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3e3a9e37e2c67fcba5320f5ec7fce767"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classAggInfo.html#a3e3a9e37e2c67fcba5320f5ec7fce767">isUpdated</a></td></tr>
<tr class="memdesc:a3e3a9e37e2c67fcba5320f5ec7fce767"><td class="mdescLeft">&#160;</td><td class="mdescRight">update flag <br /></td></tr>
<tr class="separator:a3e3a9e37e2c67fcba5320f5ec7fce767"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename AlgData&gt;<br />
class TIGLContainersAggregate&lt; AlgData &gt;</h3>

<p>base class for aggregate information </p>
<p>it holds important aggregate information and methods for updating it. it could be inherited by another more customized class if needed it is a template class that is parameterized the algorithm data field of the graph algorithm </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aaaf42f7c6d8e017f0d57ece43bbd829c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classAggInfo.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::incrementExternalMessagesCount </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>currNumMessages</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>incrementing the number of exteranl Messages after a single node compute in a superstep </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">currNumMessages</td><td>the number of external output messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4f4f5a3183bfed15fb25f8564ef1137c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classAggInfo.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::localAggregateInit </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>ssIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numLocActiveNodes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>reseting the aggregate parameters before the new superstep </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ssIndex</td><td>the superstep index </td></tr>
    <tr><td class="paramname">numLocActiveNodes</td><td>number of local active nodes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a816fe8ed65f8c026c96e36a17e149f2e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<div class="memtemplate">
template&lt;typename VERTEX_ITERATOR &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classAggInfo.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::localAggregateUpdate </td>
          <td>(</td>
          <td class="paramtype">VERTEX_ITERATOR&#160;</td>
          <td class="paramname"><em>vertexIt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>currNumMessages</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>updating the aggregate information after a single node execution during a superstep </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexIt</td><td>iterator to the executed vertex </td></tr>
    <tr><td class="paramname">currNumMessages</td><td>the output number of messages after vertex execution </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aadbf3019d3dfe78da479e1e69befc203"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classAggInfo.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::prepareAggregateSysMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> *&#160;</td>
          <td class="paramname"><em>aggSysInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Preparing the aggregate information system message (at the end of the superstep) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aggSysInfo</td><td>pointer to the received external message </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5bdf6265b94980fd94f690af72ec777f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classAggInfo.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::setNumLocalActiveNoes </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numActive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>set the number of local active nodes at the end of a superstep </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numActive</td><td>the number of local active nodes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/home/mohamed/code/tigl/src/common/containers/<a class="el" href="tiglContainersAggregate_8hpp_source.html">tiglContainersAggregate.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:17:01 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
